local Map = class {
	init = function(self,src,tileset)
		local source
	
		if type(src) == "string" then
			source = require(src)
		elseif type(src) == "table" then
			source = src
		else
			error("Invalid source type "..type(src),2)
		end
		
		self.mapWidth = source.w
		self.mapHeight = source.h
		self.tileWidth = source.tileW
		self.tileHeight = source.tileH
		self.tileScale = source.tileScale
		self.tiles = source.tiles
		
		self.tileset = tileset
	end,
	
	draw = function(self)
		local scaledW,scaledH
	
		for i=1,self.mapHeight do
			for j=1,self.mapWidth do
				scaledW = self.tileWidth*self.tileScale
				scaledH = self.tileHeight*self.tileScale
			
				if self.tiles[i][j] > 0 then
					Texture.draw(self.tileset[self.tiles[i][j]],j*scaledW-scaledW,i*scaledH-scaledH,0,scaledW,scaledH)
				end
			end
		end
	end,
}

return Map