local Animation = {}

function Animation.load(source,speed)
	if type(source) == "string" then
		source = require(source)
	end

	local anim = {}
	anim.time = 0
	anim.source = {}
	anim.speed = speed or 1
	anim.loop = true
	
	local last = 0
	
	for i,v in pairs(source) do
		anim.source[i] = {name = v.name,time = last,length = v.length}
		last = last + v.length
	end
	
	function anim.update(dt)
		anim.time = anim.time + dt * anim.speed
		
		if anim.loop then
			if anim.time > (anim.source[#anim.source].time + anim.source[#anim.source].length) then
				anim.time = 0
			end
		end
	end
	
	function anim.getCurrent()
		local ret = anim.source[1].name
		
		for i,v in pairs(anim.source) do
			if anim.time >= v.time then
				ret = v.name
			end
		end
		
		return ret
	end
	
	function anim.reset()
		anim.time = 0
	end
	
	return anim
end

return Animation