local Scale = {}

function Scale:init(resW,resH)
	self.targetW = resW
	self.targetH = resH
	self.translateX = 0
	self.translateY = 0
	self.scale = 1
	
	self.scaleFill = false
end

function Scale:resize(w,h)
	local sx = w/self.targetW
	local sy = h/self.targetH
	
	if sx > sy then
		self.scale = sy
		self.translateX,self.translateY = (w - self.targetW * self.scale)/2,0
	else
		self.scale = sx
		self.translateY,self.translateX = (h - self.targetH * self.scale)/2,0
	end
end

function Scale:push()
	love.graphics.push()
	if not self.scaleFill then
		love.graphics.setScissor(
			self.translateX,
			self.translateY,
			love.graphics.getWidth() - self.translateX * 2,
			love.graphics.getHeight() - self.translateY * 2
		)
		love.graphics.translate(self.translateX,self.translateY)
		love.graphics.scale(self.scale,self.scale)
	else
		love.graphics.scale(love.graphics.getWidth()/self.targetW,love.graphics.getHeight()/self.targetH)
	end
end

function Scale:pop()
	love.graphics.setScissor()
	love.graphics.pop()
end

function Scale:getWorldPosition(x,y)
	local scale = 1 / self.scale
	
	return math.floor((x - self.translateX) * scale),math.floor((y - self.translateY) * scale)
end

return Scale