local Scene = {}

function Scene.loadScene(scene)
	Scene.scene = require(scene)
end

function Scene:init(...)
	if Scene.scene then
		if Scene.scene.init then
			Scene.scene:init(...)
		end
	end
end

function Scene:update(...)
	if Scene.scene then
		if Scene.scene.update then
			Scene.scene:update(...)
		end
	end
end

function Scene:draw(...)
	if Scene.scene then
		if Scene.scene.draw then
			Scene.scene:draw(...)
		end
	end
end

function Scene:mousemoved(...)
	if Scene.scene then
		if Scene.scene.mousemoved then
			Scene.scene:mousemoved(...)
		end
	end
end

function Scene:keypressed(...)
	if Scene.scene then
		if Scene.scene.keypressed then
			Scene.scene:keypressed(...)
		end
	end
end

function Scene:mousepressed(...)
	if Scene.scene then
		if Scene.scene.mousepressed then
			Scene.scene:mousepressed(...)
		end
	end
end

return Scene