local Texture = {}
Texture.textures = {}

--missing texture thing stuff
local nilimg = love.image.newImageData(128,128,"rgba8")
local flipData

for i=0,nilimg:getHeight()-1 do
	for j=0,nilimg:getWidth()-1 do
		if i%32 < 15 then
			if j%32 < 15 then
				nilimg:setPixel(j,i,1,0,1)
			else
				nilimg:setPixel(j,i,0,0,0)
			end
		else
			if j%32 > 15 then
				nilimg:setPixel(j,i,1,0,1)
			else
				nilimg:setPixel(j,i,0,0,0)
			end
		end
	end
end

nilimg = love.graphics.newImage(nilimg)

local function flipX(x,y)
	return flipData:getPixel(flipData:getWidth()-x-1,y)
end

local function flipY(x,y)
	return flipData:getPixel(x,flipData:getHeight()-y-1)
end

function Texture.load(name,dir,filter)
	local img = love.graphics.newImage(dir)
	img:setWrap("repeat","repeat")
	if filter then img:setFilter(filter,filter) end
	Texture.textures[name] = img
end

function Texture.loadAtlas(dir)
	local atlas = dir
	
	if type(dir) == "string" then
		atlas = require(dir)
	end
	
	local data = love.image.newImageData(atlas.img)
	local imgs = {}
	
	for i,v in pairs(atlas.data) do
		local img = love.image.newImageData(v.w,v.h)
		img:paste(data,0,0,v.x,v.y,v.w,v.h)
		
		if v.flipX then
			flipData = img
			local tempimg = img:clone()
			tempimg:mapPixel(flipX)
			img = tempimg
			flipData = nil
		end
		
		if v.flipY then
			flipData = img
			local tempimg = img:clone()
			tempimg:mapPixel(flipY)
			img = tempimg
			flipData = nil
		end
		
		table.insert(imgs,{name = v.name,img = img})
	end
	
	for i,v in pairs(imgs) do
		local img = love.graphics.newImage(v.img)
		img:setWrap("repeat","repeat")
		Texture.textures[v.name] = img
	end
end

function Texture.include(dir)
	local t = dir
	
	if type(dir) == "string" then
		t = require(dir)
	end
	
	for i,v in pairs(t) do
		if v.type == "img" then
			if v.forceload then
				Texture.textures[v.name] = Texture.load(v.name,v.source,v.filter)
			else
				Texture.textures[v.name] = {type = v.type,source = v.source,filter = v.filter}
			end
		elseif v.type == "atlas" then
			Texture.loadAtlas(v.source)
		end
	end
end

function Texture.getTexture(name)
	local img = Texture.textures[name]
	
	if img then
		if type(img) == "table" then
			if img.type == "img" then
				Texture.load(name,img.source,img.filter)
			end
		end
		
		return Texture.textures[name]
	else
		return nilimg
	end
end

function Texture.replace(target,source)
	if type(source) == "string" then
		source = Texture.textures[source]
	end

	Texture.textures[target] = source
end

function Texture.draw(name,x,y,angle,sx,sy,ox,oy)
	local img = Texture.getTexture(name)

	x = x or 0
	y = y or 0
	angle = angle or 0
	sx = sx or img:getWidth()
	sy = sy or img:getHeight()
	
	love.graphics.draw(img,x,y,angle,sx/img:getWidth(),sy/img:getHeight(),ox,oy)
end

function Texture.rect(filltype,x,y,w,h,color)
	color = color or Color()
	local r,g,b,a = love.graphics.getColor()
	color:push()
	love.graphics.rectangle(filltype,x,y,w,h)
	love.graphics.setColor(r,g,b,a)
end

return Texture